;=============================================================================
; 	 - Nokia5110 (Nokia3310)    PCD8544
;	   :   
;-----------------------------------------------------------------------------
;  : R0, R6, R16, R17, R18, ZL, ZH
;=============================================================================
	;  LCD  
	.equ LCD_DC_port  = PORTB
	.equ LCD_DC   = 1			;  - /  PORTB.1
	.equ LCD_SCE_port = PORTB
	.equ LCD_SCE  = 2			; .    PORTB.2
	.equ LCD_SDIN_port = PORTB
	.equ LCD_SDIN = 3			;   PORTB.3
	.equ RES_port = PORTB
	.equ RES 	  = 4			;    PORTB.4
	.equ LCD_SCLK_port = PORTB
	.equ LCD_SCLK = 5			;   PORTB.5
	
	.include "Font_6x8.asm" 			;  
;==============================================================================
;		    LCD
;------------------------------------------------------------------------------
lcd_init_tab: 
		.db 0x21, 0xBC, 0x06, 0x13, 0x20, 0x0C
		; 0x21 ; (PD=0, V=0, H=1) . ; .  
		; 0xBC ;  (Vop) 0xC8 - !  (0xBC)
		; 0x06 ;   (Temp coefficent)
		; 0x13 ;  (LCD bias mode(n=4) 1:48)
		; 0x20 ; (PD=0, V=0, H=0) . ; .  
		; 0x0C ;  (D=1, E=0) 
;     0  0x7F (  080  0xFF).
; 048 ( 0xC8)  ,    0x3F ( 0xB).

;==============================================================================
;		  LCD
; !       / lcd_init,
;			    .
;----------------------------------------------------------------------------
lcd_init: 
			; 
		sbi RES_port,RES				;   RES
		DELAY 1							;  32 
		cbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		rcall Delay10us					; 10 
		
			;  LCD
		cbi RES_port,RES				;   LCD
		DELAY 1							;   32 
		sbi RES_port,RES				;   LCD
		;
		rcall Delay10us					; 10 
		sbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		DELAY 1							;  32 
		
		ldi ZL,low(lcd_init_tab*2) 		;   
		ldi ZH,high(lcd_init_tab*2) 	;
		ldi R17,6 						;-  = 6
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		rcall lcd_loop 					; 6   LCD
		
		ret ;
;============================================================================
;		     LCD
; [temp = char] -  (ASCII) 
;============================================================================
lcd_put_char:
		
		cpi temp,168					;    
		brne  PC+3						;
		subi temp,(-24)					;     (192)
		rjmp fnt_1						;
		cpi temp,184					;    
		brne  PC+3						;
		subi temp,(-9)					;     (193)
		rjmp fnt_1						;
		
		cpi temp,175					;   . I
		brne  PC+3						;
		subi temp,(-19)					;     (194)
		rjmp fnt_1						;
		cpi temp,191					;   . i
		brne  PC+3						;
		subi temp,(-4)					;     (195)
		rjmp fnt_1						;
		
fnt_2:	cpi temp,128					;    128
		brmi fnt_1						;    
		subi temp,64					;
		
fnt_1:	clr temp1 						;
		ldi ZL,low(font_tab*2-32*5) 	;  
		ldi ZH,high(font_tab*2-32*5) 	;   
		;  ,   5
		add ZL,temp 					;  . 
		adc ZH,temp1 					;   
		lsl temp 						;    4
		rol temp1 						;
		lsl temp 						;
		rol temp1 						;
		add ZL,temp 					;  . 
		adc ZH,temp1 					;
		ldi temp1,6 					;   
		clr r0 							;
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
		rjmp lcd_send1 					;   LCD
;============================================================================
;	 N   LCD  program memory
;     LCD   
; [temp1 = N] -  
; [Z = ] -     FLASH   SRAM
;----------------------------------------------------------------------------
lcd_send:
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
lcd_loop:
		lpm 							;   1-  
		adiw ZL,1 						;  
lcd_send1:
		ldi temp2,8 					; 8- 
lcd_loop1:
		cbi LCD_SCLK_port,LCD_SCLK 		;  SCLK
		nop								; 
		nop								; 
		nop								; 
		nop								; 
		sbrc r0,7 						;  
		sbi LCD_SDIN_port,LCD_SDIN 		;  
		sbrs r0,7 						;   
		cbi LCD_SDIN_port,LCD_SDIN 		;  SDIN
		lsl r0 							;  ( )
		
		rcall Delay10us					;  
		
		sbi LCD_SCLK_port,LCD_SCLK 		;  SCLK
		rcall Delay10us					;  
		
		dec temp2 						;    , -
		brne lcd_loop1 					;    . 
		
		cbi LCD_SDIN_port,LCD_SDIN 		;  
		cbi LCD_SCLK_port,LCD_SCLK 		;  SCLK
		rcall Delay10us					;   
		
		dec temp1 						;    , -
		brne lcd_loop 					;    . 
		sbi LCD_SCE_port,LCD_SCE 		;  (SCE=1)
		sbi LCD_DC_port,LCD_DC 			; D/C =1   
		
		ret 							; 
;============================================================================
;		     LCD
;[ temp = X,     1]
;----------------------------------------------------------------------------
lcd_XY: 
		sbrs temp,7 					;   =1,
		ori temp,0x40 					;     Y,
		mov r0,temp 					;      X
		ldi temp1,1 					;  1 
		cbi LCD_SCE_port,LCD_SCE		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		
		rjmp lcd_send1 					; 
		
;============================================================================
;			 LCD
;----------------------------------------------------------------------------
lcd_clr:
		ldi temp,0x40 					;Y = 0
		rcall lcd_XY 					;
		ldi temp,0x80 					;X = 0
		rcall lcd_XY 					;
		ldi temp1,84 					; 84 
lcd_clr1:
		push temp1 						; temp1
		ldi temp,32 					; 
		rcall lcd_put_char 				;
		pop temp1 						; temp1
		dec temp1 						;
		brne lcd_clr1 					;
		ret
		
;=============================================================================
; 	     10 
; 		c   RCALL  RET
;-----------------------------------------------------------------------------
	Delay10us:
			PUSH Temp1
			LDI	Temp1, 23
			DEC	Temp1
			BRNE PC-1
			POP	Temp1
		RET
;==============================================================================
;		    
;         0.
; Z -   ;
;------------------------------------------------------------------------------
	Str_LCD:
		push ZL					;   
		push ZH					;  
		lpm 					;  
		tst R0					;    0,  -
		breq w_str				;  
		mov temp,R0				;
		rcall lcd_put_char		;   LCD
		pop ZH					;  
		pop ZL					;  
		adiw Z,1				;   .
		rjmp Str_LCD			;  
		
w_str:	pop ZH					;  
		pop ZL					;  
		
 		ret
		
;==============================================================================
;		      
;  temp -     R6 -   
;------------------------------------------------------------------------------
Dig_x2:
		;    
		ldi ZL,LOW((Dig_0)*2)	;  1-  
		ldi ZH,HIGH((Dig_0)*2)	; .   0
		
		tst temp				;   0, 
		breq dig_w				;   
adr_dg:	adiw Z,24				;   
		dec temp				;   , -
		brne adr_dg				;  . 
		
dig_w:		;   
		ldi temp1,12			;   
		rcall lcd_send			;   LCD
		;     
		mov temp,r6				;
		rcall lcd_XY			;
		ldi temp,0x03			;  4 
		rcall lcd_XY			;
		;   
		ldi temp1,12			;   
		rcall lcd_send			;   LCD
		
		;     
		ldi temp,12				;
		add r6,temp				;
		mov temp,r6				;
		rcall lcd_XY			;
		ldi temp,0x02			;  3 
		rcall lcd_XY			;
		
		ret
;==============================================================================

	.EXIT
